/**
 * Quoridor server and related libraries
 * Copyright (C) 2009-2010 Jaroslav Tulach <jaroslav.tulach@apidesign.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. Look for COPYING file in the top folder.
 * If not, see http://www.gnu.org/licenses/.
 */


package cz.xelfi.quoridor.visidor;

import java.util.EventListener;

/** Channel referring back what happens in a {@link BoardPane}.
 *
 * @author Jaroslav Tulach <jtulach@netbeans.org>
 */
public interface BoardListener extends EventListener {
    /** Notifies listeners about a change in the {@link BoardPane}.
     * 
     * @param ev the event, usually next move applicable to the board
     */
    public void boardChanged(BoardEvent ev);
}
